local fname = current_lua_file()
local dir = current_lua_dir()
local skinname = current_lua_dir_leaf():sub(2)

-- keep around a temporary boolean for each frame that stores
-- whether or not we have drawn the frame for that bar during
-- this draw cycle.
-- this is easier than trying to figure out whether all the
-- various UI functions need to explicitly trigger a bottom bar
-- frame draw -- we can just call bottom_bar.ensure_frame()
-- everywhere a frame /might/ be needed, and trust that
-- repeated calls won't lead to repeated frame draws.
bottom_bar_frame_states = bottom_bar_frame_states or setmetatable({},weak_mt)
function new_frame.clear_bottom_bar_frame_states()
  cleartable(bottom_bar_frame_states)
end

_ENV[skinname].BottomBar = function(_ENV)

depends(fname)

local bottom_bar = {}



add_resize_callback | function ()


  local text_context = new_text_rendering_context {
    name = 'BottomBar titles',
  }

	local title_fh,cond,secret in fonts

	local layout_w,layout_h in layout

	if layout_h<1000
		bottom_bar.height=round(layout_h*.26)
		bottom_bar.planet_row_scale = bottom_bar.height/260
	else
		bottom_bar.planet_row_scale = 1
		bottom_bar.height=260	
	end



	local function list(x0,x1)

		if x0==x1 return x0 end

		return x0,list(x0+1,x1)

	end

  local title_y=bottom_bar.height+6

  local shadow_options = {sigma=6,spread=.6,opacity=.5}

  local lazy_title = weak_memoizeNN | function(pt,text)
    local rval = text_context.lazy_word_render(
      format('orig%d',pt),
      text
    )

    if not rval.draw_shadow
      rval = shadowed_word(shadow_options,rval)
    end

    local w in rval
    function rval.hcentered_shadow_draw(x,y)
      x-=w*.5
      rval.draw_shadow(x,y)
      return rval.draw(x,y)
    end

    return rval
  end

  insert(bottom_bar,..lazy_title)

	bottom_bar.title = restore_color | function (str,...)
    
    --bottom_bar.ensure_frame()

    set_frame_color4(1,1,1,1)

    local text = format(str,...)





    local x,y,w,h = lazy_title(42,text).hcentered_shadow_draw(layout_w*.5,title_y)

    --[[

		local x,y,w,h=hcentered_text(secret,20 or 60,
			layout_w*.5, title_y,format(str,...))

    -]]

		--set_frame_color4(1,1,1,.5)
		--glBox(x,y,w,h)
		return x,y,w,h
	end

  function bottom_bar.star_rename_rect()

    local cx = layout_w*.5
    local w=260

    return cx-w*.5,bottom_bar.height, w, 42

  end
  insert(bottom_bar,..title_y)

	bottom_bar.center_pane_title = restore_color | function (str,...)
    

    set_frame_color4(1,1,1,1)
    local mx,my,mw,mh=center_pane_rect()
		local x,y,w,h=hcentered_text(secret,56,
			mx+mw*.5, title_y,format(str,...))

		--set_frame_color4(1,1,1,.5)
		--glBox(x,y,w,h)
		return x,y,w,h
	end


	local arrow_offset=10
	function bottom_bar.right_arrow(x,valid)

    ReportFrame.draw_arrow(x+arrow_offset,bottom_bar.height+18)

    set_frame_color4(0,0,0,0)
		local img = dir..(valid and "arrow.png" or "iarrow.png")

		return draw_mimage(img,x+arrow_offset,bottom_bar.height+11)
	end

	local w,h=mimage_dims(dir.."arrow.png" or "iarrow.png")
	function bottom_bar.left_arrow(x,valid)

		local img = dir..(valid and "arrow.png" or "iarrow.png")
		local x,y=x-arrow_offset-w,bottom_bar.height+11
		return rotate_at_fun(x+.5*w,y+.5*h,180,draw_mimage,img,x,y)
	end

	function bottom_bar.rect()
		return 0,0,layout_w,bottom_bar.height
	end



end


return bottom_bar

end