local fname = current_lua_file()
local dir = current_lua_dir()
local skinname = current_lua_dir_leaf():sub(2)

_ENV[skinname].EncounterPanel = function(_ENV)

depends(fname)

local encounter = {}


-- this should really be split into 2 parts, one of which
-- does fleet_panel, and the other which does encounter_report

add_resize_callback( function ()

	local cond,small_fonts in fonts
	local action = action_colors

	local layout_w,layout_h in layout

	local fh = small_fonts and 48 or 64

	local h=bottom_bar.height

	local mid = 162
	local side = round(.5*(layout_w-mid))
		







	--function encounter.pinned_left()
		--console(..side)
		--console(..pinned_w)
		--console(side-pinned_w)
	--	return pinned_w,0,side-pinned_w,h
	--end




  --[[
	local img=dir.."encounter_center.png"
	local iw,ih=eimage_dims(img)

	function encounter.center()

		draw_expandN(img,
			side,-6,
			round(.5*iw),mid-iw,nil,
			round(.8*ih),h-ih+4,nil)

		return side,0,mid,h
	end
  --]]

  function encounter.center_x_w()
    return round_all ( side,mid )
  end

	function encounter.center_action(str,...)
		return hcentered_text(cond,fh,side+.5*mid,h*.5,str)
	end

  function encounter.center(x,y)
    return side+.5*mid,h*.5+fh*.2
  end



		--[[
	function encounter.upper_action(str,...)
		return hcentered_text(secret,fh,side+.5*mid,h*.6,str)
	end

	function encounter.lower_action(str,...)
		return hcentered_text(secret,fh,side+.5*mid,h*.1,str)
	end
	--]]

	local pinned_w=120

	--function encounter.layout_fleets_and_planets(planets,pinned)


--		return {..left,..right,..draw_actions}
--	end

	local function left()
		return 0,0,side,h
	end

	local function right()
		return side+mid,0,side,h
	end

	function encounter.civilian_frame(civilian_pack)
		local w = civilian_pack.w+2

		draw_expandN(img,
			.5*(layout_w-w),-6,
			round(.5*iw),w-iw,nil,
			round(.8*ih),h-ih+4,nil)
	end

	local civ_y=40

	function encounter.civilian_center_text(civilian_pack,str)
		return hcentered_text(cond,fh,layout_w*.5,5,str)
	end

	local civ_dx=60

	function encounter.civilian_left_text(civilian_pack,str)
		return hcentered_text(cond,fh,layout_w*.5-civ_dx,5,str)
	end

	function encounter.civilian_right_text(civilian_pack,str)
		return hcentered_text(cond,fh,layout_w*.5+civ_dx,5,str)
	end



	local function civilian_layout(my_ships,their_ships, civilian_ships)
		local side = floor(layout_w/3)
		local x,y,h=0,0,bottom_bar.height
		local ihstart



		--console("first pack")
		local i=0

		::repack::

		i++

		if i>16
			error("civilian encounter ship packing error")
		end

		--console("packing with",..side)

		local my_pack=pack_ships(my_ships,'right_align',true,..x,..y,'w',side,..h,..ihstart)
		local their_pack=pack_ships(their_ships,'x', layout_w-side,..y,'w',side,..h,..ihstart)

		local civilian_pack=pack_ships(civilian_ships,'right_align',true,'x', side,'y',civ_y,
			'w',layout_w-2*side,'h',h-civ_y,..ihstart)

		ihstart = max(my_pack.ih,their_pack.ih,civilian_pack.ih)

		if ihstart ~= min(my_pack.ih,their_pack.ih,civilian_pack.ih)
			goto repack
		end

		if side==floor(layout_w/3) 
			--console("considering longer repack")
		
			if my_pack.w<side*.6 and their_pack.w<side*.6
				side = floor(layout_w/4)
				ihstart=nil

				--console("doing longer repack")

				goto repack

			end
		end

		-- center the civilians
		local min_civw=300
		if civilian_pack.w<300

			for _,p ; civilian_pack.ship_positions
				p.x+= .5*(civilian_pack.w-min_civw)
			end 

			civilian_pack.w=min_civw
		end


		local civ_shift=civilian_pack.w-(layout_w-2*side)

		for _,p ; civilian_pack.ship_positions
			p.x+= .5*civ_shift
		end

		for _,p ; my_pack.ship_positions
			p.x -= .5*civ_shift+5
		end

		for _,p ; their_pack.ship_positions
			p.x += .5*civ_shift+5
		end

		--civilian_pack.frame_w=layout_w-2*side 


		return my_pack,their_pack,civilian_pack
	end

	function encounter.layout_ships(my_ships,their_ships, civilian_ships, planets, pinned)

		if civilian_ships
			return civilian_layout(my_ships,their_ships, civilian_ships)
		end


    local planet_layout

		local left,right  = left, right

		if planets
			local pw = planets_display_width( planets )
		
			local pinw = pinned and  pinned_w or 0

			left = fun4( pinw,0,.5*(layout_w-pw) -pinw, bottom_bar.height)
			right = fun4( .5*(layout_w + pw), 0, .5*(layout_w-pw) , bottom_bar.height)
		
    
      planet_layout = { x=(layout_w-pw)*.5,w=pw }
    end

		local _,ih0,ih1

		local pack0=pack_ships(my_ships,"right_align",true,"rect",left)
		local ih0=pack0.ih

		local pack1 = pack_ships(their_ships,"rect",right)
		local ih1=pack1.ih

		if ih1>ih0
			pack0=pack_ships(my_ships,"right_align",true,"rect",left,"ihstart",ih1)
		end

		if ih0>ih1
			p1=pack_ships(their_ships,"rect",right,"ihstart",ih0).ship_positions
		end

		return pack0,  pack1, nil, nil, planet_layout

	end

	encounter.draw_pinned = restore_color | function(x)
		set_frame_color4(1,.25,.2,current_alpha())
		x-=pinned_w*.5
		--console("drawing",x,pinned_w,h)
		--glBox(x,0,pinned_w,h)
    --memconsole(stack_trace(1,4))
		hcentered_text(cond,fh,x,h*.6,format("%sFleet\nPinned",add_kern(.2)))
	end


end)


return encounter

end