
local centered_text, draw_expandN, eimage_dims in _ENV

local fname = current_lua_file()
local dir = current_lua_dir()
local skinname = current_lua_dir_leaf():sub(2)

_ENV[skinname].PlanetOverlays = function(_ENV)


depends(fname)

local overlays = {}

local s2w = {

	Tiny = 40,

	Small = 140,
	Large = 260,
	Medium = 200,
	
  --Hephaestus = 320,
  Hephaestus=305,

  Huge = 292,
  Zeus = 280,

  Cronos = 260,
}

local s2y = {	
	Tiny=0,
	Small=12,
	Medium=12,
	Large=-10,
  Cronos=0,
	Huge=-4,
  Zeus = 0,
  Hephaestus=-1,
}

function Planet.row_width(planet,scale)
  --print(..planet.drawer)
  return (s2w[planet.drawer] or s2w[planet.size])*scale
end

function Planet.row_yshift(planet,scale)
  return (s2y[planet.drawer] or s2y[planet.size] )*scale
end

add_resize_callback | function ()

	local small_font,small_fh,action_fh,cond in fonts
	local layout_w,layout_h in layout
	local actions = action_colors
	local planet_row_scale in bottom_bar


	overlays.planet_spacing=round(48*planet_row_scale)
	overlays.planet_w=round(253*planet_row_scale)


  --print('planet_wish',overlays.planet_w,planet_row_scale)

  --[[
	overlays.size_to_yshift,overlays.size_to_width={},{}

	for size in pairs(s2w)
		overlays.size_to_yshift[size]=planet_row_scale*s2y[size]*260/300
		overlays.size_to_width[size]=planet_row_scale*s2w[size]*260/300
	end
  --]]




	local pop_bk=dir.."pop_bar_bk.png"
	local pop_bar_img = dir.."pop_bar.png"



	overlays.pop_bar = restore_color | function (x,str,color,fade,current_pop,next_pop,text_color)


		if(not bar_hw)
			bar_hw=floor(.5*mimage_dims(dir.."pop_bar.png"))
		end

		--set_frame_color4(1,0,0,1)

		local y=bottom_bar.height-20
		y+=-1

		string_color_fun(color)()
		if(fade) 
			fade=smooth3(fade)
			fade_color(fade) 
		end
	

		local bx,by=x-bar_hw+1,y+1

		if not current_pop or current_pop==1
			draw_mimage(pop_bk,bx,by)
		else
     -- '0e335cff'
      string_color_fun('0e335cff')()
			draw_mimage(pop_bk,bx,by)
      			fade_color(fade) 

      string_color_fun(color)()
      			fade_color(fade) 

			local w,h=mimage_dims(pop_bk)

			local center=w*.4;
			local solid_w = center + (w-center)*current_pop;
			local trans_w = center + (w-center)*next_pop;


			draw_sub_texture( 
				bx+.5*(w-solid_w),by, solid_w, h,
				.5*(w-solid_w), 0, solid_w, h,
				pop_bk )

			fade_color(.6) 

			draw_sub_texture( 
				bx+.5*(w-trans_w),by, trans_w, h,
				.5*(w-trans_w), 0, trans_w, h,
				pop_bk )

		end

		set_frame_color4(1,1,1,1)
		if(fade) fade_color(fade) end
	
		draw_mimage(pop_bar_img,x-bar_hw,y+1)

		if text_color
			string_color_fun(text_color)()
			if(fade) fade_color(fade) end
		end


		local x,y,w,h=centered_text(small_font,small_fh,x-2,y+12,str)
		--set_frame_color4(1,1,1,.4)	
		--glBox(x,y,w,h)
		--set_frame_color4(1,1,1,1)	
	end


	local low_text_y=20
	local tab_w=142

	overlays.action_tab = restore_color | function (x,text,color,alpha)
		local w,h=tab_w,104

		local rx,ry,rw,rh= draw_frame(x-.5*w,-63,dir.."action_tab.png", (alpha or 1))

    if text


		  actions[color](alpha)

		  centered_text(cond,action_fh,x,low_text_y,text)

    end

		return rx,ry,rw,rh
	end

  insert(overlays,..low_text_y)

  overlays.centered_icon = restore_color | function(x,icon)
    return SCOPE_call(icon_radius_hint=18, 
      icon.draw,x,low_text_y-1)
  end

  overlays.automate_icon = restore_color | function(x)
    return SCOPE_call(icon_radius_hint=18, 
      notification_icons.misc.automate.draw,x+tab_w*.5-28,low_text_y-1)
  end

  overlays.retreat_icon = restore_color | function(x)
    return SCOPE_call(icon_radius_hint=18, 
      notification_icons.misc.retreat.draw,x-tab_w*.5+28,low_text_y-1)
  end


	do

		 overlays.action_tab2 = {} 
	 
		 function overlays.action_tab2.draw(x)
			local w,h=tab_w,104

			local x = x-.5*w
			local y = -63

			return draw_expandN(dir.."action_tab.png", x,y, nil, 70,30)

			--return draw_frame(x-.5*w,-63,dir.."action_tab.png",alpha or 1)

			--actions[color](alpha)

			--centered_text(cond,action_fh,x,20,text)

			--return rx,ry,rw,rh
		end

		local function long_box(x,rx,ry,rw,rh)
			return x-tab_w*.5,ry,tab_w,rh
		end

		function overlays.action_tab2.lower_text(x,text,...)

			return long_box(x, centered_text(cond,action_fh,x,low_text_y,format(text,...) ) )

		end

		function overlays.action_tab2.upper_text(x,text,...)

			return long_box(x, centered_text(cond,action_fh,x,low_text_y+action_fh*.8,format(text,...) ) )

		end


	end


	do
		
		local y=bottom_bar.height*.47
		overlays.invalid_message = restore_color | function(x,planet,...)

			local cx=x+.5*overlays.planet_w

			--local y = y + overlays.size_to_yshift[size]
			
      local y = y + planet:row_yshift(planet_row_scale*260/300)

			local text=format(...) 
			local rx,ry,rw,rh = hcentered_text_dims(cond,action_fh,x,y,text)

			rx,ry,rw,rh+=box_expand(4,4)

			set_frame_color4(0,0,0,.4)
			glBox(rx,ry,rw,rh)

			set_frame_color4(.7,.7,.7,1)
			hcentered_text(cond,action_fh,x,y,text)

		end
	end

	overlays.action_overlay = restore_color(function (x,...)

		local r,g,b,a = current_color()

		set_frame_color4(.2,.4,.8,a*.4)

		local w,h=action_fh*3,action_fh*1.3
		local y=bottom_bar.height*.55

		local rx,ry,rw,rh = x-w*.5,y-h*.5,w,h
		glBox(rx,ry,rw,rh)


		set_frame_color4(r,g,b,a)

		centered_text(cond,action_fh,x,y,format(...) )

		return rx,ry,rw,rh

	end)


	local function white()
		set_frame_color4(1,1,1,1)
	end



  local activity_to_tab_color = {

    Trade = color_param 'ffff00ff',
    Mining = color_param 'hsva: 15; 100; 80; 100',
    ['Synthesize Food'] = color_param 'hsva: 100; 70; 100; 100',
    show_metal_warning= color_param 'f72a0a',
  }
  local white_color = catch(1,1,1,1)

	overlays.production_tab = restore_color | function (x,text,alpha, is_auto, progress,next_progress, is_growth)
		local w,h=162,104

	
		if(progress and progress>1) progress=1 end
		if(next_progress and next_progress>1) next_progress=1 end


		--local img = (progress and "\\production_tab") or "\\special_production"

		local img = "production_tab"

		local rx,ry,rw,rh= draw_frame(x-.5*w,-63,dir..img..".png" ,alpha or 1)


		white()
		if(alpha) fade_color(alpha) end

		local complete = dir.."complete.png"

		if( is_growth)
			complete = dir.."growth_tab.png"
		end

    local complete_tab_color = white_color

		if (text=="Trade") or (text=="Mining") or (text=='Synthesize Food') 
			progress=1
			complete = dir.."white_tab.png"
      complete_tab_color = activity_to_tab_color[text]
		end

    if SCOPE.show_metal_warning

			complete = dir.."white_tab.png"
      complete_tab_color = activity_to_tab_color.show_metal_warning

    end

		if(text=="Research")
			complete = dir.."research_tab.png"
		end

		if(next_progress and next_progress>0)

			local p=next_progress
      set_frame_color4 | complete_tab_color()
			fade_color(.45)

			--sprint("subdraw",rx*progress,ry,rw,rh)

			local iw,ih=mimage_dims(complete)

  			subdraw_mimage(
				  complete,
				  rx,ry,iw*p,ih,
				  0,0,iw*p,ih)


		end

		white()
		if(alpha) fade_color(alpha) end

		if(progress and progress>0)

			local iw,ih=mimage_dims(complete)


			--console("tab",progress)
      call_with_frame_color(complete_tab_color,
			subdraw_mimage,
				complete,
				rx,ry,iw*progress,ih,
				0,0,iw*progress,ih)


		end

		--local color = (is_auto and action.blue) or white
		--color()

		if(is_auto)
			text..="*"
		end

		centered_text(cond,action_fh,x,20,text)

		return rx,ry,rw,rh

	end




end


return overlays


end