local fname = current_lua_file()
local dir = current_lua_dir()
local skinname = current_lua_dir_leaf():sub(2)

_ENV[skinname].TopBar = function(_ENV)

depends(fname)

local top_bar = {}

add_resize_callback | function ()

	local small_fonts, small_fh, small_font, bold, top_fh in fonts

	top_bar.height=40

	local layout_w,layout_h in layout
	local font = "fonts/bitstream/vera.TTF"

	--local top_y=layout_h-top_bar.height+14

	local frame_top=screen_h/layout.scale

  local clickable_height = top_bar.height-4
  local clickable_y = frame_top-clickable_height
	local top_y = frame_top-top_bar.height+14

  local next_year_x0=layout_w-153
  local new_rendered_word in new_text_rendering_context { name = 'top_bar'}

	local txp,typ=4,6

	function top_bar.make_tip(x)

		local y = frame_top-top_bar.height-top_fh-typ

		local draw_tip = restore_color | function (str)

      local hover_activation in SCOPE
      if (hover_activation or 0) <= 0
        return
      end

			local rx,ry,rw,rh = hcentered_text_dims( font, top_fh, x, y, str)

			set_frame_color4(0,0,0,.2*hover_activation)
			local bx,by,bw,bh = rx-txp, ry-typ,rw+2*txp,rh+2*typ
			glBox(bx,by,bw,bh)

			set_frame_color4(1,1,1,hover_activation)
			hcentered_text( font, top_fh, x, y, str)

			--return bx,by,bw,bh
		end

		return draw_tip
	end


	local coinsx= 8

  local function tiny_icon_prefixed_text(icon_name,x0,...)
    local advance = tiny_icons[icon_name].draw(x0,top_y)
    local x,y,w,h = display_text( font, top_fh, x0+advance, top_y, format(...) )
    return x0,clickable_y,w+advance,clickable_height
  end


  local layout_w in layout
  local cramped_display = layout_w <top_fh*80
  local compact_display = (not cramped_display) and (layout_w <top_fh*105)
  --print(..cramped_display,..compact_display)
  --print(..layout_w, layout_w/top_fh)

  local function cases(cramped,compact,normal)
    if cramped_display return cramped end
    if compact_display return compact end
    return normal or compact
  end

  local wrenchx=coinsx+top_fh*cases(8,9)

  local foodx = wrenchx+top_fh*cases(6,6,7)

  local popx = foodx+top_fh*cases(4.5,7,7.5)

  local metalx = popx+top_fh*cases(5.5,5.5,5.5)

  local sciencex=metalx+top_fh*cases(6,7,9)

  local tradex=sciencex+top_fh*cases(8,9,12)

  local diplox=tradex+top_fh*cases(5,5,8)

  local fleetx=diplox+top_fh*cases(7,8,9)



  insert(top_bar,..cramped_display)
  insert(top_bar,..fleetx,..diplox,..metalx,..foodx)


  local extra_left_padding=12
  local function expand_left(x,y,w,h)
    return x-extra_left_padding,y,w+extra_left_padding,h
  end

	function top_bar.empire_production(...)
    return expand_left | tiny_icon_prefixed_text( 'wrench', wrenchx,...)
	end

	function top_bar.empire_science(...)
    return expand_left | tiny_icon_prefixed_text( 'test_tube', sciencex,...)
	end

	local ai_x=layout.layout_w*.6-top_fh*10
	

  --local races_x=ai_x+top_fh*8


  function top_bar.empire_fleets(...)
    return expand_left | tiny_icon_prefixed_text( 'fleet', fleetx,...)
  end


  
  function top_bar.empire_food(...)
    return expand_left | tiny_icon_prefixed_text( 'corn_5', foodx,...)

   -- return expand_left | ResourceGlyph.corn.top_bar_str(  font, top_fh, foodx, top_y, format(...) )
  end

  function top_bar.empire_pop(...)
    return expand_left | tiny_icon_prefixed_text( 'people', popx,...)

   -- return expand_left | ResourceGlyph.corn.top_bar_str(  font, top_fh, foodx, top_y, format(...) )
  end


  function top_bar.empire_metal(...)
      local rx,ry,rw,rh = tiny_icon_prefixed_text( 'ingot_pile', metalx,...)

      --call_with_frame_color(catch(1,1,1,.4),glBox,|) expand_left(rx,ry,rw,rh)

      return rx,ry,rw,rh

  --  return expand_left | ResourceGlyph.metal.top_bar_str(  font, top_fh, metalx, top_y, format(...) )
  end

  function top_bar.empire_influence(...)
    local rx,ry,rw,rh = expand_left | ResourceGlyph.handshake.top_bar_str(  font, top_fh,diplox,top_y,format(...))
    --clickable_y,w+advance,clickable_height
    --glBox(rx,ry,rw,rh)
    return rx,clickable_y,rw,clickable_height
  end

	function top_bar.empire_coins(...)

		--local _,_,w = coins_pstring( top_fh*1.2, coinsx, frame_top-top_bar.height+13, "" )
--    local w=.3
      local rx,ry,rw,rh = expand_left | ResourceGlyph.coin.top_bar_str(  font, top_fh,coinsx,top_y,format(...))
      return rx,clickable_y,rw,clickable_height
	end


	function top_bar.trade_pool(...)
      --memconsole(stack_trace(1,4))
      return expand_left | tiny_icon_prefixed_text( 'spaceship', tradex,...)

		--return display_text( font, top_fh, tradex, top_y, format(str,...) )
	end

  function top_bar.trade_route_anchor()
    return tradex+top_fh*.5, top_y-14
  end

	insert(top_bar,..sciencex,..tradex,..wrenchx,..popx)

	top_bar.empire_AI = restore_color | function (active,name)
    local ai_y=top_y-32
    set_frame_color4(0,0,0,.75)
    glBox | centered_box(ai_x,ai_y+6,150,23)

		if  active
      set_frame_color4(1,1,1,1)
			return hcentered_text( font, top_fh, ai_x, ai_y, name.." (AI)" )
		end
		
	  local g=.7
		set_frame_color4(g,g,g,1)

		return hcentered_text( font, top_fh, ai_x, ai_y, name )
	end

  --[[
	function top_bar.races_button()
		return hcentered_text( bold, top_fh, races_x, top_y, "RACES" )
	end
  --]]




	



	--local undox=min(layout_w-layout_w*.2,layout_w-top_fh*18)


  local extra_design_sep=.6

  local year_anchor=next_year_x0-top_fh*(13.8+2+extra_design_sep)

  local zoom_center = year_anchor - top_fh*1.6

  top_bar.zoom_tip = top_bar.make_tip(zoom_center)

	top_bar.draw_zoom_center_at = function(x,y)
    draw_mimage(dir..'zoom_center.png',pixel_snap(x,y) )
	end

  top_bar.zoom_center_img = function()
    local rx,ry,rw,rh=centered_box(zoom_center,top_y+8,30,36)
    --call_with_light_white(glBox,rx,ry,rw,rh)

		top_bar.draw_zoom_center_at(rx+4,ry+5)
--    draw_mimage(dir..'zoom_center.png',pixel_snap(rx+4,ry+5) )

    return rx,ry,rw,rh
  end

	function top_bar.draw_zoom_out_at(x,y)
    draw_mimage(dir..'zoom_out_white.png',pixel_snap(x,y))		
	end

  top_bar.zoom_out_img = function(valid)
    local rx,ry,rw,rh=centered_box(zoom_center-26,top_y+8,22,36)
		if not valid
			set_frame_color4(.65,.65,.65,1)
		end
		top_bar.draw_zoom_out_at(rx+6,ry+10)
    return rx,ry,rw,rh
  end

	function top_bar.draw_zoom_in_at(x,y)
    draw_mimage(dir..'zoom_in_white.png',pixel_snap(x,y))		
	end

  top_bar.zoom_in_img = restore_color| function(valid)
    local rx,ry,rw,rh=centered_box(zoom_center+26,top_y+8,22,36)
    
		if not valid
			set_frame_color4(.65,.65,.65,1)
		end

    top_bar.draw_zoom_in_at(rx+4,ry+10)
    --call_with_light_white(glBox,rx,ry,rw,rh)
    return rx,ry,rw,rh
  end



	local undox=year_anchor-top_fh*8
  insert(top_bar,..undox)
	top_bar.undo_tip = top_bar.make_tip(undox)
	top_bar.undo_arrow = restore_color( function(can_undo)
	

    local rx,ry,rw,rh=centered_box(undox-20,top_y+8,36,36)
    --call_with_light_white(glBox,rx,ry,rw,rh)


    draw_mimage(dir..(can_undo and'undo_white.png' or 'undo_grey.png'),
      pixel_snap(rx+6,ry+3) )

    return rx,ry,rw,rh

	end)

	top_bar.redo_arrow = restore_color( function(can_redo)


    local rx,ry,rw,rh=centered_box(undox+20,top_y+8,36,36)
    --call_with_light_white(glBox,rx,ry,rw,rh)

    draw_mimage(dir..(can_redo and'redo_white.png' or 'redo_grey.png'),
      pixel_snap(rx+1,ry+3) )


    return rx,ry,rw,rh

		--return display_text( font, top_fh, undox, top_y, ' -->' )
	end)



  local gear_x = year_anchor  + top_fh*(3.2+2+extra_design_sep)
  function top_bar.gear_icon()
    local advance = tiny_icons.gear.draw(gear_x,top_y)
    return gear_x, frame_top-top_bar.height, advance,top_bar.height
  end
	top_bar.gear_tip = top_bar.make_tip(gear_x+top_fh*.8)

  local design_x = year_anchor + top_fh*3.1
  function top_bar.design_icon()
    --local advance = tiny_icons.
    
    --return SCOPE_call('icon_radius_hint',20,
    --  notification_icons.misc.refit.simple_draw,design_x,top_y+6)

    local advance = tiny_icons.refit.draw(design_x,top_y)
    return design_x, frame_top-top_bar.height, advance,top_bar.height
  end
	top_bar.design_tip = top_bar.make_tip(design_x+top_fh*1)

	function top_bar.undo_text(str,...)
		--console(..str)
		return br_text( font, top_fh, undox, top_y, format(str,...) )
	end

	function top_bar.redo_text(str,...)
		return display_text( font, top_fh, undox, top_y, format(str,...) )
	end



	function top_bar.year_text(str,...)
		return br_text( font, top_fh, next_year_x0-top_fh*.5, top_y, format(str,...) )
	end



	function top_bar.rect()
		return 0,layout_h-top_bar.height,layout_w
	end


  local next_year_render = new_rendered_word {
        text='NEXT TURN',
        font_key='next_turn_font',
      }


  local gg_render = new_rendered_word {
        text='GAME OVER',
        font_key='next_turn_font',
      }

  local function bar_rect()
    local x = 0
    local y =  screen_h/layout.scale -top_bar.height+1
    local w = layout_w
    local h=top_bar.height

    return x,y,w,h
  end

  function report_icon_y()
    local y =  screen_h/layout.scale -top_bar.height
    local effective_h=TopBarFrame.turn_button_h
    return y-effective_h
  end

   insert(top_bar,..bar_rect)

   top_bar.next_year_word = function()
    local word = gui_player().eliminated and gg_render or next_year_render
    return element | word.draw_hcentered(layout_w-TopBarFrame.turn_button_w*.5, top_y-4)
   end

	 top_bar.end_year_element = hover_id_speed(2,|) function ()
		
    
    set_frame_color4(1,1,1,1)
    --glBox | TopBarFrame.next_turn_element | bar_rect()

    local word = gui_player().eliminated and gg_render or next_year_render

    word.draw_hcentered(layout_w-TopBarFrame.turn_button_w*.5, top_y-4)

    TopBarFrame.draw_next_turn_icon | bar_rect()

--    print(..element)

    return element | TopBarFrame.next_turn_element | bar_rect()

    --return br_text( font, top_fh, layout_w-top_fh*.8, top_y, "+" )
    
    --return br_text( font, top_fh, layout_w-top_fh*.8, top_y, "+" )
	end

	function top_bar.draw()
      TopBarFrame.draw_bar | bar_rect()
  end

  --[[
	local img=dir.."top_slice.png"

	function top_bar.draw()
    do
      

      return
    end

		set_frame_color4(1,1,1,1)

		local w,h=eimage_dims(img)
		local by,ty=4,4

		return draw_expandN(img,0,
			-- (layout_h-top_bar.height+1),
			(screen_h/layout.scale-top_bar.height+1),
			2,layout_w-w,nil,
			round(h*.5), top_bar.height-h )

		--return draw9slice(img,0,layout_h-top_bar.height+1,
		--	layout_w,top_bar.height,
		--	1,by,0,h-ty-by)
	end
  --]]

end


return top_bar

end

reload_script [[GUI\~GalaxyMap\GalaxyMap.lua]] 