depends '@PlanetPopPane'

local hover_bk_box = restore_color | function ( x,y,w,h)
--  set_frame_color4(0,0,0,.75*SCOPE.hover_activation)
 -- set_frame_color4(0,0,0,.6*SCOPE.hover_activation) 

  set_frame_color4(0,0,0,.6)

  return glBox(x,y,w,h)
end

UI_File | function(_ENV)

PlanetPopPane(_ENV) -- load the PlanetPopPane


local hints = {}

--local coin_hint_params, research_hint_params, trade_text_h


local top_info_speed = 4

function top_hover_fun(f)
  return hover_id_speed(top_info_speed, restore_color | f)
end


local function clear_hover_hints()
	cleartable( hints )
end

add_resize_callback( clear_hover_hints )
set_order_callback('top_bar_info',clear_hover_hints)



local function open_tech_pane()
	open_fullscreen_pane(tech_pane)
end



local function draw_top_hover(x,name)
  set_frame_color4(1,1,1,1)
  local layout_h,layout_w in layout
  local w,h=positioned_text_dims(name)
	local y=layout_h-h-top_bar.height

  if FLAG.hcentered_tooltip
    x-=w*.5
  end

	local x0,y0=x,y
	local yp=fonts.top_fh*.2

	x,y,w,h+=box_expand(4,yp)


	hover_bk_box(
		x,y,w,h )

	positioned_text_texture(name,x0,y0)

end

local function top_hover(x0, rendered)
  if (SCOPE.hover_activation or 0) > 0
    SCOPE_frame_activation( frame_activation()*SCOPE.hover_activation, draw_top_hover,x0,rendered.name)   
  end
end

insert(_ENV,..top_hover)


local plus = "+"..add_align(.8)
local neg = add_kern(.2).."-"..add_align(.8)


add_resize_callback | function()

  local hover_text_context = new_text_rendering_context {
    default_font_key = 'vera16',
    default_bold_key = 'vera_bold16',
    name = 'topbar_hover',
    text_width=layout.layout_w*.5,
  }


  render_top_hover_text = function (cache_suffix,text)
    return hover_text_context.new_rendered_text {
      ..text,
      ..cache_suffix,
    }
  end

  render_hover_text=render_top_hover_text


end

--!! coins
local get_coins_text =  weak_memoizeNN | function(empire)

  --print(empire.has_inhabited_planets)


  if not empire.has_inhabited_planets
    return render_hover_text('economic_breakdown',"No Economy")
  end

	local income, taxes, trade, ship_up, planet_up,net_agreement,
		foreign_trade_bonus,food_bonus,tank_up,hostile_up = empire : income()

  local text=''

  if taxes
	  text..=format("%s%d<COIN> Taxes", plus, taxes)
  end

	if trade>0
			text..=format("\n+%d<COIN> Trade", trade)
	end

	if ship_up>0
			text..=format("\n%s%d<COIN> Ships", neg, ship_up)
	end

	if planet_up>0
			text..=format("\n%s%d<COIN> Buildings", neg, planet_up)
	end


	if (tank_up or 0)>0
			text..=format("\n%s%d<COIN> Ground Units", neg, tank_up)
	end

	if (hostile_up or 0)>0
			text..=format("\n%s%d<COIN> Hostile Environments", neg, hostile_up)
	end


  local paying  = net_agreement
	if paying~=0
			text..=format("\n%s<COIN> Agreements", plus_form | net_agreement)
	end

	if food_bonus > 0
			text..=format("\n%s<COIN> Surplus <FOOD>", plus_form | food_bonus)
	end


  return render_hover_text('economic_breakdown',shorthand_format | text)
end

local draw_coins = top_hover_fun | function ()
	local empire = gui_player()
	local credits in! empire

	local income, taxes, trade, ship_up, planet_up =  empire : income()

--  local income, taxes, trade, ship_up, planet_up in INIT.zero


	local neg_credits = credits < 0
	if neg_credits
		credits*=-1
	end

	local neg_income = income < 0

	if neg_income
		income*=-1
	end

	if(credits>20000 and income > 500)
		credits=k_form(credits)
		income=k_form(income)
	end


  local income_str = format("(%s%s)",neg_income and '-' or '+', income)

  if not empire.has_inhabited_planets
    income_str=''
  end


	local cx,cy,cw,ch = top_bar.empire_coins("%s%s " .. income_str, neg_credits and '-' or '', credits)

	element(cx,cy,cw,ch )

  top_hover(10,get_coins_text(gui_player()) )

end

--!! fleets
local get_fleet_text = weak_memoizeNN | function(empire)
  return render_hover_text('fleet_breakdown',"Fleet Report")  
end

local draw_fleets = top_hover_fun | function ()
	--local el = element( top_bar.empire_science("%s/%s (+%s)", science,needed_science or "---",research) )
  

  --set_frame_color4(.6,.6,.6,1)
  local x,y,w,h = top_bar.empire_fleets( gui_player().num_fleet_ships )


  local el = element (x,y,w,h)
  el.on_click = (leftside_pane == fleet_list_pane and leftside_pane_showing()) and  close_leftside_pane or fleet_list_pane.open 
  el.on_hover = hand_cursor

  top_hover(top_bar.fleetx,get_fleet_text(gui_player()) )

end

--!! food

local draw_food = top_hover_fun | function ()
  local empire = gui_player()
  local net =empire.net_food_production
  local next_net =  empire.projected_net_food_production

  --set_frame_color4(1,0,0,1)
  local str =  (net< 0 and '' or '+') .. tostring (net)

  if empire.starving
    str = mark_color ( format_as_hex(0xff,80,80) ) .. str
  end

  if next_net~=net
    local next_str = format("(%s)",|) (next_net< 0 and '' or '+') .. tostring (next_net)

    if (next_net >= 0) and (net < 0) and (empire.starving)
      next_str = mark_color ( format_as_hex(0xff,0xff,0xff) ) .. next_str
    end

    str .. = next_str
  end


  local el = element |top_bar.empire_food | str

  top_hover(top_bar.foodx,get_food_hover_text(empire) )
end


--!! population

local get_planet_list = weak_memoizeNN | function (empire)
  local push, list = pusher {}
  for p ; empire.planets
    push | p
  end
  return list
end

local get_population_text = weak_memoizeNN | function(empire)
  local haduir = 0
  local teros = 0  
  local orthin = 0
  local phidi = 0
  local gremak = 0
  local tinker = 0
  local yoral = 0
  local human = 0
  local enfi = 0
  local thresher = 0
  local scavenger = 0
  local lummox = 0
  local pell = 0
  local algorian = 0
  local tarib = 0
  local viscid = 0
  local wrem = 0
  local spice_monger = 0
  local gaiad = 0
  local android = 0
  local tanks = 0
  for i,planet in ipairs | get_planet_list (empire)
    if planet.inhabited
	  for race,p in pairs(planet.pop_and_tanks)
	    if remove_race_suffix(race) == "haduir" then haduir += p end
	    if remove_race_suffix(race) == "teros" then teros += p end
	    if remove_race_suffix(race) == "orthin" then orthin += p end
		if remove_race_suffix(race) == "phidi" then phidi += p end
		if remove_race_suffix(race) == "gremak" then gremak += p end
		if remove_race_suffix(race) == "tinker" then tinker += p end
		if remove_race_suffix(race) == "yoral" then yoral += p end
		if remove_race_suffix(race) == "human" then human += p end
		if remove_race_suffix(race) == "enfi" then enfi += p end
		if remove_race_suffix(race) == "thresher" then thresher += p end
		if remove_race_suffix(race) == "scavenger" then scavenger += p end
		if remove_race_suffix(race) == "lummox" then lummox += p end
		if remove_race_suffix(race) == "pell" then pell += p end
		if remove_race_suffix(race) == "algorian" then algorian += p end
		if remove_race_suffix(race) == "tarib" then tarib += p end
		if remove_race_suffix(race) == "viscid" then viscid += p end
		if remove_race_suffix(race) == "wrem" then wrem += p end
		if remove_race_suffix(race) == "spice_monger" then spice_monger += p end
		if remove_race_suffix(race) == "gaiad" then gaiad += p end
		if remove_race_suffix(race) == "android" then android += p end
		if remove_race_suffix(race) == "tanks" then tanks += p end
      end
	end
  end
  local text = 'Population Report\n'
  if haduir > 0 then text..=format("\nHaduirs: %d", haduir) end
  if teros > 0 then text..=format("\nTeros: %d", teros) end
  if orthin > 0 then text..=format("\nOrthins: %d", orthin) end
  if phidi > 0 then text..=format("\nPhidi: %d", phidi) end
  if gremak > 0 then text..=format("\nGremaks: %d", gremak) end
  if tinker > 0 then text..=format("\nTinkers: %d", tinker) end
  if yoral > 0 then text..=format("\nYorals: %d", yoral) end
  if human > 0 then text..=format("\nHumans: %d", human) end
  if (enfi>0 or thresher>0 or scavenger>0 or lummox>0 or pell>0 or algorian>0 or tarib>0 or viscid>0 or wrem>0 or spice_monger>0 or gaiad>0) then text..=format("\n") end
  if enfi > 0 then text..=format("\nEnfi: %d", enfi) end
  if thresher > 0 then text..=format("\nThreshers: %d", thresher) end
  if scavenger > 0 then text..=format("\nScavengers: %d", scavenger) end
  if lummox > 0 then text..=format("\nLummox: %d", lummox) end
  if pell > 0 then text..=format("\nPells: %d", pell) end
  if algorian > 0 then text..=format("\nAlgorians: %d", algorian) end
  if tarib > 0 then text..=format("\nTaribs: %d", tarib) end
  if viscid > 0 then text..=format("\nViscids: %d", viscid) end
  if wrem > 0 then text..=format("\nWrems: %d", wrem) end
  if spice_monger > 0 then text..=format("\nSpice Mongers: %d", spice_monger) end
  if gaiad > 0 then text..=format("\nGaiads: %d", gaiad) end
  if (android>0 or tanks>0) then text..=format("\n") end
  if android > 0 then text..=format("\nAndroids: %d", android) end
  if tanks > 0 then text..=format("\nTanks: %d", tanks) end
  return render_hover_text('population_breakdown',shorthand_format | text)
end

local draw_pop = top_hover_fun | function ()
  local empire = gui_player()
  local total_pop = empire:calc_total_pop()

  local str = tostring(floor | total_pop)

  local el = element | top_bar.empire_pop | str


  el.on_click = ( leftside_pane == planet_pop_pane and leftside_pane_showing() ) and  close_leftside_pane or planet_pop_pane.open 
  el.on_hover = hand_cursor

  --top_hover(top_bar.popx,get_food_hover_text(empire) )
  top_hover(top_bar.popx,get_population_text(gui_player()) )

end

--!! metal

local draw_metal = top_hover_fun | function ()
  local empire=gui_player()
  local el = element | top_bar.empire_metal | format( '%d (%s)' , empire.metal, plus_form | empire.mem_metal_production )  


  top_hover(top_bar.metalx,|) metal_hover_text | empire
end

-- production
local production_text = weak_memoizeNN | function(empire)
  return format('(+%d)',empire.total_raw_hammer_production)
end

local get_production_text = weak_memoizeNN | function(empire)
  return render_hover_text('production_breakdown',"Planetary Report")  
end


local draw_production = top_hover_fun | function ()
	--local el = element( top_bar.empire_science("%s/%s (+%s)", science,needed_science or "---",research) )
  

--  set_frame_color4(.6,.6,.6,1)
  local x,y,w,h = top_bar.empire_production | production_text | gui_player()

  --glColor4d(1,1,1,.3)
  --glBox(x,y,w,h)

  local el = element (x,y,w,h)

  el.on_click = ( leftside_pane == planet_list_pane and leftside_pane_showing() ) and  close_leftside_pane or planet_list_pane.open 
  el.on_hover = hand_cursor


  top_hover(top_bar.wrenchx,get_production_text(gui_player()) )
end

--!! research

local draw_research = top_hover_fun | function ()

	local empire = gui_player()

  local science=empire.apparent_beakers
	local researching, tech in empire
  local tech_info = empire.tech_info[researching]

	local needed_science= researching and empire:research_cost(researching)

	local research = empire : mem_research()
	

	if(science>20000 and (needed_science or 0)>20000 and research > 500)
		science = k_form(science)
		needed_science = needed_science and k_form(needed_science)
		research = k_form(research)
	end

  local str = "(---)"

  if empire.researching
    if top_bar.cramped_display
      str = format("%s/%s", science,needed_science or "---")
    else
      str = format("%s/%s (+%s)", science,needed_science or "---",research)
    end
  end

	local el = element( top_bar.empire_science( str ) )

	insert(el,
		'on_click',(fullscreen_pane==tech_pane) and close_fullscreen_pane or open_tech_pane,
		'sound',(fullscreen_pane==tech_pane) and 'SCREEN_OPEN' or 'SCREEN_CLOSE',
		'on_hover',hand_cursor)


  top_hover(top_bar.sciencex,|) research_hover_text | empire
end


--!! trade
local get_trade_text = weak_memoizeNN | function(empire)
	local active = empire.active_trade
	local total = empire.total_tradeship_space

  local trade_capacity, total_cargo_space, starving, need_food_lift in empire
  local lift_capacity = empire:transport_lift_capacity()

  local push, lines = pusher {}

  local function pushf(...)
    push | format(...)
  end

  local function catf(...)
    lines[#lines] ..= format(...)
  end


  local num_transports = 0
  local active_transports = 0
  local lift_transports = 0
  local used_routes = 0
  local etas = {}

  for ship,info ; empire.tradeship_pool
    
    num_transports++
    local eta in info

    if eta~=-1
      active_transports++

      if eta==0
        lift_transports++
      else
        etas[eta] = 1 + (etas[eta] or 0)
      end

    end  

  end

  if num_transports==0
    push 'We have no transports (<TRANSPORT>) in the trade pool, '
    push 'so there is 0<CARGO> available.'
  else
    pushf('We have %d<TRANSPORT> in the trade pool, which provide%s', active_transports,  active_transports==1 and 's' or '')
    pushf('%d<CARGO> cargo space.', total_cargo_space)
  end

  push ''
	pushf('%d<CARGO> is needed to transport <FOOD> between our colonies.',empire.need_food_lift )

  if total_cargo_space < need_food_lift
    push ''
    pushf('Our citizens will starve due to a %s<CARGO> shortage!', color_desc_text( 'FF0000', tostring | empire.need_food_lift-total_cargo_space)  )
  end

	--local income = min(active,empire.trade_capacity)

	local income, taxes, trade, ship_up, planet_up,net_agreement,foreign_trade_bonus = empire : income()

  local income=trade
  local capacity = empire.trade_capacity
  local active = empire.active_trade

  if (active < trade_capacity)
    active_routes = active
  else
    active_routes = trade_capacity
  end

  if (active_transports>0) and (income > 0)
    push ''
  	pushf( 'The remaining %d<CARGO> earn%s +%d<COIN> through trade.', active, active==1 and 's' or '', income)
      

    pushf( '   %d of %d available trade routes are active.', active_routes, trade_capacity)
    pushf( '   Build <MARKET> or found colonies to increase available routes.')

    if (active > trade_capacity)
        pushf( '   %d<CARGO> capacity is currently idle.', active - trade_capacity)
    end

    if foreign_trade_bonus > 0
      pushf('   Access to foreign markets increases trade income by %d<COIN>!',foreign_trade_bonus)
    end

  else
    push ''
    if empire.trade_capacity > 0
      pushf( 'With more <CARGO> we could earn up to %d<COIN> through trade.', empire.trade_capacity )
    else
      pushf(  'With more <CARGO>, and an expanded empire, we would gain the ability to earn <COIN> through trade.' )
    end
	end

  push ''

  if lift_capacity==0
    push | grey_desc_text(.7,|) 'No <TRANSPORT> are available for civilian transport.'
  else
    pushf('%d<TRANSPORT> are available for colonist transport.',lift_transports)
  end

  if next | etas
    for eta, num in spairs | etas
      pushf( '  %d<TRANSPORT> will be available after %d turn%s.',num,eta,eta==1 and '' or 's')
    end
  end

  push '' 

  if num_transports > active_transports
    pushf('%d<TRANSPORT> are currently transporting civilians.', num_transports-active_transports)
  end

 
  
  return render_hover_text('trade_info',shorthand_format | table.concat(lines,'\n')) 
end

local draw_trade = top_hover_fun | function ()
	local empire = gui_player()

	local active = empire.active_trade
	local total = empire.total_tradeship_space

	local text
	local name = 'trade_info'

  local net = empire.total_cargo_space - empire.need_food_lift

  if net >= 0 
    text = format('+%d',net)
  else
    text = format('%s%d%s',
      mark_color 'FF0000',
      net,
      mark_color 'FFFFFF'
      )
  end


  --make grey if needed
    text ..= format(' %s/ %d',
      empire:mem_transport_lift_capacity() <= 0 and mark_color '999999' or '',
      empire.mem_trade_capacity
      ) 


  --[[
	if a~=total
		text=format(
			"%d(%s+%d%s)", 
				active , 
				mark_color '999999',
				total-active, 
				mark_color 'FFFFFF'
		)
	else
		text=format(
			"%d", 
				active
		)
	end
  --]]






	insert( element(top_bar.trade_pool( text )),
      on_click = open_trading_pane,
      on_hover = hand_cursor,
      --map_key=trading_pane,
		)


  top_hover(top_bar.tradex,get_trade_text(gui_player()) )
end

local get_influence_text = weak_memoizeNN | function(empire)
  local pushf,text,push in new_text_pusher()
  push | shorthand_format | format('Influence (<INFLUENCE>) is key resource for diplomacy.')
  push | shorthand_format | format("Your empire has <b>%d</b><INFLUENCE>.",gui_player().influence)  
  return render_hover_text('diplo_hover_text',text'\n' )  
end

local draw_influence = top_hover_fun | function()


  local str = format("%d (%s)",gui_player().influence,plus_form |gui_player(). mem_influence_income)
  insert(element(top_bar.empire_influence(str)),
    'on_click', toggle_diplo_pane,
    'on_hover', hand_cursor)

  top_hover(top_bar.diplox,influence_hover_text(gui_player()) )
end

--!! options menu
local draw_gear = top_hover_fun | function()

  local el = element | top_bar.gear_icon()
  el.on_hover=hand_cursor
  if midscreen_pane == main_menu_pane
    el.on_click = close_midscreen_pane
  else
    el.on_click=open_main_menu
  end

  top_bar.gear_tip('Game Menu')
end

--!! ship design
local function ship_design_click(el)
  open_new_design_screen()
end

local draw_design_icon = top_hover_fun | function()

  local el = element | top_bar.design_icon()
  el.on_hover=hand_cursor
  el.on_click=ship_design_click

  top_bar.design_tip('Ship Design')
end

function draw_resources()
  --set_frame_color4(1,1,1,1)

	draw_coins()


  draw_production()

  draw_research()

  draw_pop()

  draw_food()

  draw_metal()

  draw_fleets()

	draw_trade()

  draw_gear()

  draw_influence()

  draw_design_icon()
end

end

reload_script [[GUI\~GalaxyMap\GalaxyMap.lua]] 

